#include <iostream>
#include <string>
#include <vector>

#include "pqueue.h"

int main()
{
    int yourMark = 1;

    pqueue<std::string, int>  pq;
    pq.push("fejfajas",1);
    pq.push("izomlaz",1);
    pq.push("labtores",8);
    pq.push("influenza",3);
    pqueue<double, double>    pq2;  // tenyleg template?
    pq2.push(2.2,2.2);
    pq2.push(2.2,13.0);
    pq2.push(2.2,4.1);
    if ( sizeof(pq2) < 48 )  // buta implementacio elkerulese
        yourMark = pq.count(1);  // hany db 1-es prioritasu van?

    const pqueue<std::string,int> cpq = pq;
    pq.pop();   // a legmagasabb prioritasu torlese
    if ( cpq.count(8)  &&  ! pq.has("labtores") ) 
        yourMark = pq.max();  // a legnagyobb prioritas

    pq.push("natha",3).push("vizsgadrukk",0);
    if( pq.pop() == "influenza" )  // azonos prioritas eseten a korabbi
        yourMark = pq.size();

    std::vector<std::string> vs;
    pq.getprior(1,vs);    // bemasolja vs-be az osszes 1-es prioritasut, 
    if ( vs[0] == "fejfajas" && vs[1] == "izomlaz" )
        ++yourMark;
    
    std::cout << yourMark << std::endl;   
 
    return 0;
}
