#include <iostream>
#include <cstdlib>
#include <string>
#include "set.h"

using namespace std;

int main()
{
    int your_mark = 1;
/* 2
    set<int>    your_set;  // capacity is up on you
    set<char*> other_set; // just check set really a template
    other_set.put("Hello").put("world");

    your_set.put(1);    // put to set
    your_set.put(1);    // no effect
    your_set.put(2).put(3).put(4);
    your_set.del(3);    // delete from set
    your_set.del(4);
    your_set.del(5).del(6);    // no effect
    your_mark = your_set.size();    // size() returns double
*/
/* 3    
    const set<int> c_set = your_set;
    your_set.del(1);
    if ( c_set.has(1) && ! your_set.has(1) ) 
        ++your_mark;
*/
/* 4
    your_set = ~c_set;  // complement 
    if ( !your_set.has(1) && !your_set.has(2) )
        ++your_mark;
    srand(static_cast<unsigned int>(your_set.size())); // initialize generator
    for( int i = 0; i < 100000; ++i) 
    {
        int random_number = rand();
        if ( c_set.has(random_number) &&  your_set.has(random_number)  ||
            !c_set.has(random_number) && !your_set.has(random_number) )
        {
            // operator~ is not working properly
            --your_mark;
            break;
        }
    }
*/
/* 5
    your_set-=2;        // del(2)
    your_set-=3;        // del(3)
    your_set-=4;        // del(4)
    your_set-=5;        // del(5)
    your_mark = (~your_set).size();
*/    
    cout << "Your mark is " << your_mark << endl;

    return 0;
}

