//
//	hospital in Linz
//	Porkolab, 2003.
//

#include <iostream>
#include <string>
#include <vector>

#include "pqueue.h"

int main()
{
    int yourMark = 1;

/* 2-es
    pqueue<std::string, int>  pq;
    pq.push("Kopfschmerz",1);
    pq.push("Muskelkater",1);
    pq.push("Beinbruch",8);
    pq.push("Erkltung",3);
    pqueue<double, double>    pq2;  // check: works on other types too?
    pq2.push(2.2,2.2);
    pq2.push(2.2,13.0);
    pq2.push(2.2,4.1);
    if ( sizeof(pq2) < 48 )		// avoid stupid implementation
        yourMark = pq.count(1); // how many elements exist with priority 1?
*/

/* 3-as
    const pqueue<std::string,int> cpq = pq;
    pq.pop();   // remove the highest priority element
    if ( cpq.count(8)  &&  ! pq.has("Beinbruch") ) 
        yourMark = pq.max();  // the highest priority level
*/

/* 4-es    
    pq.push("Grippe",3).push("Streifwunde",0);
    if( pq.pop() == "Erkltung" )  // if same priority: get the older
        yourMark = pq.size();
*/   

/* 5-os 
    std::vector<std::string> vs;
    pq.getprior(1,vs);    // copy all elements with priority 1 into vs 
    if ( vs[0] == "Kopfschmerz" && vs[1] == "Muskelkater" )
		++yourMark;
*/
	std::cout << yourMark << std::endl;   
 
    return 0;
}
